%global impl   src/main/java/com/thoughtworks/qdox/parser/impl
%global grammar src/grammar

Name:           qdox
Version:        2.0.3
Release:        1
Summary:        High speed and small footprint parser
Epoch:          0
License:        ASL 2.0
URL:            https://github.com/paul-hammant/qdox
BuildArch:      noarch
Source0:        https://github.com/paul-hammant/qdox/archive/%{name}-%{version}/%{name}-%{version}.tar.gz
Source1:        qdox-MANIFEST.MF
BuildRequires:  maven-local byaccj jflex
BuildRequires:  mvn(org.apache.maven.plugins:maven-assembly-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-invoker-plugin)
BuildRequires:  mvn(org.codehaus.mojo:exec-maven-plugin) mvn(org.sonatype.oss:oss-parent:pom:)

%description
QDox is used by documentation tools and active code generators.It provides parser for
fully extracting class/interface/method definitions.It is a high speed, small footprint parser.

%package        help
Summary:        API docs for qdox
Provides:       qdox-javadoc = %{version}-%{release}
Obsoletes:      qdox-javadoc < %{version}-%{release}

%description    help
Javadocs for qdox.


%prep
%autosetup -n %{name}-%{name}-%{version}
find -name *.jar -delete
	
%pom_remove_parent

%pom_remove_plugin :animal-sniffer-maven-plugin
%pom_remove_plugin :maven-assembly-plugin
%pom_remove_plugin :maven-failsafe-plugin
%pom_remove_plugin :maven-invoker-plugin
%pom_remove_plugin :jflex-maven-plugin
%pom_remove_plugin :maven-enforcer-plugin
%pom_remove_plugin :exec-maven-plugin

%mvn_file : qdox
%mvn_alias : qdox:qdox

%build
	
jflex -d src/main/java/com/thoughtworks/qdox/parser/impl src/grammar/lexer.flex
jflex -d src/main/java/com/thoughtworks/qdox/parser/impl src/grammar/commentlexer.flex
 
(cd ./src/main/java/com/thoughtworks/qdox/parser/impl
 byaccj -v -Jnorun -Jnoconstruct -Jclass=DefaultJavaCommentParser -Jpackage=com.thoughtworks.qdox.parser.impl ../../../../../../../grammar/commentparser.y
 byaccj -v -Jnorun -Jnoconstruct -Jclass=Parser -Jimplements=CommentHandler -Jsemantic=Value -Jpackage=com.thoughtworks.qdox.parser.impl -Jstack=500 ../../../../../../../grammar/parser.y
)

%mvn_build  -f -- -Dmaven.compiler.source=1.8 -Dmaven.compiler.target=1.8

jar ufm target/qdox-%{version}*.jar %{SOURCE1}

%install
%mvn_install

%files -f .mfiles
%doc LICENSE.txt

%files help -f .mfiles-javadoc
%doc README.md

%changelog
* Tue Aug 22 2023 xu_ping <707078654@qq.com> 0:2.0.3-1
- Upgrade version to 2.0.3

* Mon Dec 9 2019 zhujunhao <zhujunhao5@huawei.com> 0:2.0-5.M9
- Package init
